From 18c3b2ada7fbc5c2ec7563a1e97f55e627b544f1 Mon Sep 17 00:00:00 2001
From: Yuri Chornoivan <yurchor@ukr.net>
Date: Wed, 22 Aug 2012 21:29:18 +0300
Subject: [PATCH] Fix some typos in messages, docs and comments.

---
 docs/api.html.in            |    2 +-
 docs/bugs.html.in           |    2 +-
 docs/drivers.html.in        |    2 +-
 docs/drvqemu.html.in        |    4 ++--
 docs/drvtest.html.in        |    2 +-
 docs/drvxen.html.in         |    2 +-
 docs/formatdomain.html.in   |    8 ++++----
 docs/formatnode.html.in     |    4 ++--
 docs/formatnwfilter.html.in |   12 ++++++------
 docs/locking.html.in        |    2 +-
 docs/news.html.in           |    8 ++++----
 src/network/bridge_driver.c |    2 +-
 src/rpc/virnetsshsession.c  |    4 ++--
 src/util/virhash.c          |    4 ++--
 14 files changed, 29 insertions(+), 29 deletions(-)

diff --git a/docs/api.html.in b/docs/api.html.in
index 384eb77..c8fc204 100644
--- a/docs/api.html.in
+++ b/docs/api.html.in
@@ -43,7 +43,7 @@
       <li>virNetworkPtr: represent one network either active or defined (i.e.
       existing as permanent config file and storage but not currently activated.
       The function <code class='docref'>virConnectListNetworks</code>
-      allows to list all the virtualization networks actived on this node.</li>
+      allows to list all the virtualization networks activated on this node.</li>
       <li>virStorageVolPtr: represent one storage volume, usually this is used
       as a block device available to one of the domains. The function
       <code class="docref">virStorageVolLookupByPath</code> allows to find
diff --git a/docs/bugs.html.in b/docs/bugs.html.in
index 39b6725..7436a71 100644
--- a/docs/bugs.html.in
+++ b/docs/bugs.html.in
@@ -126,7 +126,7 @@
     <p>
       It may also happen that the libvirt daemon itself crashes or gets stuck,
       in the first case run it (as root) under gdb, and reproduce the sequence
-      leading to the crash, similary to a normal program provide the
+      leading to the crash, similarly to a normal program provide the
       "bt" backtrace information to where gdb will have stopped.<br/>
       But if libvirtd gets stuck, for example seems to stop processing
       commands, try to attach to the faulty daemon and issue a gdb command
diff --git a/docs/drivers.html.in b/docs/drivers.html.in
index 90b6196..24387d0 100644
--- a/docs/drivers.html.in
+++ b/docs/drivers.html.in
@@ -31,7 +31,7 @@
       <li><strong><a href="drvhyperv.html">Microsoft Hyper-V</a></strong></li>
     </ul>
 
-    <h2><a name="stroage">Storage drivers</a></h2>
+    <h2><a name="storage">Storage drivers</a></h2>
 
     <ul>
       <li><strong><a href="storage.html#StorageBackendDir">Directory backend</a></strong></li>
diff --git a/docs/drvqemu.html.in b/docs/drvqemu.html.in
index 9afae13..df99377 100644
--- a/docs/drvqemu.html.in
+++ b/docs/drvqemu.html.in
@@ -54,7 +54,7 @@
     The libvirt QEMU driver is a multi-instance driver, providing a single
     system wide privileged driver (the "system" instance), and per-user
     unprivileged drivers (the "session" instance). The URI driver protocol
-    is "qemu". Some example conection URIs for the libvirt driver are:
+    is "qemu". Some example connection URIs for the libvirt driver are:
     </p>
 
 <pre>
@@ -476,7 +476,7 @@ $ virsh domxml-from-native qemu-argv demo.args
 &lt;/domain&gt;
 </pre>
 
-    <p>NB, don't include the literral \ in the args, put everything on one line</p>
+    <p>NB, don't include the literal \ in the args, put everything on one line</p>
 
     <h3><a name="xmlexport">Converting from domain XML to QEMU args</a></h3>
 
diff --git a/docs/drvtest.html.in b/docs/drvtest.html.in
index b5814c3..66d5bab 100644
--- a/docs/drvtest.html.in
+++ b/docs/drvtest.html.in
@@ -8,7 +8,7 @@
     The libvirt Test driver is a per-process fake hypervisor driver,
     with a driver name of 'test'. The driver maintains all its state
     in memory. It can start with a pre-configured default config, or
-    be given a path to a alternate config. Some example conection URIs
+    be given a path to a alternate config. Some example connection URIs
     for the libvirt driver are:
     </p>
 
diff --git a/docs/drvxen.html.in b/docs/drvxen.html.in
index 631f7ed..0bca935 100644
--- a/docs/drvxen.html.in
+++ b/docs/drvxen.html.in
@@ -59,7 +59,7 @@
 
     <p>
     The libvirt Xen driver is a single-instance privileged driver,
-    with a driver name of 'xen'. Some example conection URIs for
+    with a driver name of 'xen'. Some example connection URIs for
     the libvirt driver are:
     </p>
 
diff --git a/docs/formatdomain.html.in b/docs/formatdomain.html.in
index 5d8f669..e671e36 100644
--- a/docs/formatdomain.html.in
+++ b/docs/formatdomain.html.in
@@ -493,7 +493,7 @@
       <dt><code>memory</code></dt>
       <dd>The maximum allocation of memory for the guest at boot time.
         The units for this value are determined by the optional
-        atttribute <code>unit</code>, which defaults to "KiB"
+        attribute <code>unit</code>, which defaults to "KiB"
         (kibibytes, 2<sup>10</sup> or blocks of 1024 bytes).  Valid
         units are "b" or "bytes" for bytes, "KB" for kilobytes
         (10<sup>3</sup> or 1,000 bytes), "k" or "KiB" for kibibytes
@@ -1491,7 +1491,7 @@
             The optional <code>event_idx</code> attribute controls
             some aspects of device event processing. The value can be
             either 'on' or 'off' - if it is on, it will reduce the
-            number of interupts and exits for the guest. The default
+            number of interrupts and exits for the guest. The default
             is determined by QEMU; usually if the feature is
             supported, default is on. In case there is a situation
             where this behavior is suboptimal, this attribute provides
@@ -1502,7 +1502,7 @@
           </li>
           <li>
             The optional <code>copy_on_read</code> attribute controls
-            wether to copy read backing file into the image file. The
+            whether to copy read backing file into the image file. The
             value can be either "on" or "off".
             Copy-on-read avoids accessing the same backing file sectors
             repeatedly and is useful when the backing file is over a slow
@@ -2795,7 +2795,7 @@ qemu-kvm -net nic,model=? /dev/null
       <dd>
         The <code>event_idx</code> attribute controls some aspects of
         device event processing. The value can be either 'on' or 'off'
-        - if it is on, it will reduce the number of interupts and
+        - if it is on, it will reduce the number of interrupts and
         exits for the guest. The default is determined by QEMU;
         usually if the feature is supported, default is on. In case
         there is a situation where this behavior is suboptimal, this
diff --git a/docs/formatnode.html.in b/docs/formatnode.html.in
index c04d04d..fcaaaaf 100644
--- a/docs/formatnode.html.in
+++ b/docs/formatnode.html.in
@@ -143,7 +143,7 @@
             </dl>
           </dd>
           <dt><code>scsi</code></dt>
-          <dd>Desribes a SCSI device.  Sub-elements include:
+          <dd>Describes a SCSI device.  Sub-elements include:
             <dl>
               <dt><code>host</code></dt>
               <dd>The SCSI host containing the device.</dd>
@@ -184,7 +184,7 @@
                 available.</dd>
               <dt><code>capability</code></dt>
               <dd>If present, an additional capability is listed via
-                the attribute <code>type</code>.  Current capabilites
+                the attribute <code>type</code>.  Current capabilities
                 include "hotpluggable" and "removable", with the
                 latter implying the following
                 sub-elements: <code>media_available</code> (0 or
diff --git a/docs/formatnwfilter.html.in b/docs/formatnwfilter.html.in
index 03bacc4..78c3b82 100644
--- a/docs/formatnwfilter.html.in
+++ b/docs/formatnwfilter.html.in
@@ -605,7 +605,7 @@
     </ul>
     <p>
      The above example indicates that the traffic of type <code>ip</code>
-     will be asscociated with the chain 'ipv4' and the rule will have
+     will be associated with the chain 'ipv4' and the rule will have
      priority 500. If for example another filter is referenced whose
      traffic of type <code>ip</code> is also associated with the chain
      'ipv4' then that filter's rules will be ordered relative to the priority
@@ -632,7 +632,7 @@
     <ul>
      <li>UINT8 : 8 bit integer; range 0-255</li>
      <li>UINT16: 16 bit integer; range 0-65535</li>
-     <li>MAC_ADDR: MAC adrress in dotted decimal format, i.e., 00:11:22:33:44:55</li>
+     <li>MAC_ADDR: MAC address in dotted decimal format, i.e., 00:11:22:33:44:55</li>
      <li>MAC_MASK: MAC address mask in MAC address format, i.e., FF:FF:FF:FC:00:00</li>
      <li>IP_ADDR: IP address in dotted decimal format, i.e., 10.1.2.3</li>
      <li>IP_MASK: IP address mask in either dotted decimal format (255.255.248.0) or CIDR mask (0-32)</li>
@@ -810,7 +810,7 @@
        <tr>
          <td>type</td>
          <td>UINT8</td>
-         <td>Bridge Protcol Data Unit (BPDU) type</td>
+         <td>Bridge Protocol Data Unit (BPDU) type</td>
        </tr>
        <tr>
          <td>flags</td>
@@ -1911,7 +1911,7 @@
       unresponsive due to its traffic being dropped.
       Therefore, the limit of connections should be rather high so that
       fluctuations in new TCP connections don't cause odd
-      traffic behavior in relaton to idle connections.
+      traffic behavior in relation to idle connections.
     </p>
 
     <h2><a name="nwfcli">Command line tools</a></h2>
@@ -2053,7 +2053,7 @@
     tree that instantiates iptables or ip6tables rules, a rule to let
     the UDP packet pass will also be necessary to be provided for those
     filtering layers. This can be
-    achieved with a rule containing an approriate <code>udp</code> or
+    achieved with a rule containing an appropriate <code>udp</code> or
     <code>udp-ipv6</code> traffic filtering node.
     </p>
 
@@ -2253,7 +2253,7 @@
 </pre>
     <p>
      Before trying out a filter using the <code>RELATED</code> state,
-     you have to make sure that the approriate connection tracking module
+     you have to make sure that the appropriate connection tracking module
      has been loaded into the host's kernel. Depending on the version of the
      kernel, you must run either one of the following two commands before
      the ftp connection with the VM is established.
diff --git a/docs/locking.html.in b/docs/locking.html.in
index 28781a4..0d039da 100644
--- a/docs/locking.html.in
+++ b/docs/locking.html.in
@@ -165,7 +165,7 @@
     <p>
       If all went well, libvirtd will have talked to sanlock
       and created the basic lockspace. This can be checked
-      by looking for existance of the following file
+      by looking for existence of the following file
     </p>
 
     <pre>
diff --git a/docs/news.html.in b/docs/news.html.in
index 3bf966b..c444765 100644
--- a/docs/news.html.in
+++ b/docs/news.html.in
@@ -255,7 +255,7 @@ and check the <a href="http://libvirt.org/git/?p=libvirt.git;a=log">GIT log</a>
       Fix mistakes in augeas lens (Daniel P. Berrange),<br/>
       Standardize whitespace used in example config files (Daniel P. Berrange),<br/>
       Remove uid param from directory lookup APIs (Daniel P. Berrange),<br/>
-      Fix check for socket existance / daemon spawn (Daniel P. Berrange),<br/>
+      Fix check for socket existence / daemon spawn (Daniel P. Berrange),<br/>
       Remove last usage of PATH_MAX and ban its future use (Daniel P. Berrange),<br/>
       maint: avoid new automake warning about AM_PROG_CC_STDC (Jim Meyering),<br/>
       build: silence libtool warning on probes.o (Eric Blake),<br/>
@@ -1694,7 +1694,7 @@ and check the <a href="http://libvirt.org/git/?p=libvirt.git;a=log">GIT log</a>
       build: fix linking on BSD (Eric Blake),<br/>
       remote: fix mingw32 build (Laine Stump),<br/>
       build: fix deep VPATH builds (Eric Blake),<br/>
-      Use ENAMETOOLONG if the the socket path is longer than UNIX_PATH_MAX (Guido Günther),<br/>
+      Use ENAMETOOLONG if the socket path is longer than UNIX_PATH_MAX (Guido Günther),<br/>
       build: avoid RHEL 5 build failure on LXC (Eric Blake),<br/>
       build: use gnulib fdatasync (Eric Blake),<br/>
       Fix virFileOpenTty definition on Win32 (Daniel P. Berrange),<br/>
@@ -6380,7 +6380,7 @@ and check the <a href="http://libvirt.org/git/?p=libvirt.git;a=log">GIT log</a>
       Convert QEMU driver all hotunplug code from pci_del to device_del (Daniel P. Berrange),<br/>
       Support hot-unplug for USB devices in QEMU (Daniel P. Berrange),<br/>
       Tweak container initialization to make upstart/init happier (Daniel P. Berrange),<br/>
-      Avoid creating top level cgroups if just querying for existance (Daniel P. Berrange),<br/>
+      Avoid creating top level cgroups if just querying for existence (Daniel P. Berrange),<br/>
       Support VCPU hotplug in QEMU guests (Daniel P. Berrange),<br/>
       Fix mis-leading error message in pool delete API (Daniel P. Berrange),<br/>
       Fix typo in QEMU migration command name (Daniel P. Berrange),<br/>
@@ -7039,7 +7039,7 @@ and check the <a href="http://libvirt.org/git/?p=libvirt.git;a=log">GIT log</a>
       Enable udev instead of hal on F12 / RHEL-6 or later (Daniel P. Berrange),<br/>
       python: Actually implement list*Interfaces bindings (Cole Robinson),<br/>
       esx: Handle 'vmxnet3' in esxVMX_FormatEthernet() (Matthias Bolte),<br/>
-      Fix check for existance of cgroups at creation (Daniel P. Berrange),<br/>
+      Fix check for existence of cgroups at creation (Daniel P. Berrange),<br/>
       Fix virt-aa-helper when host and os.type arch differ (Jamie Strandboge),<br/>
       Add translation of PCI vendor and product IDs (David Allan),<br/>
       Add scsi_target device type (David Allan),<br/>
diff --git a/src/network/bridge_driver.c b/src/network/bridge_driver.c
index 7866287..59b2c10 100644
--- a/src/network/bridge_driver.c
+++ b/src/network/bridge_driver.c
@@ -2877,7 +2877,7 @@ networkCreateInterfacePool(virNetworkDefPtr netdef) {
             }
             else {
                 virReportError(VIR_ERR_INTERNAL_ERROR, "%s",
-                               _("Direct mode types requires interface names"));
+                               _("Direct mode types require interface names"));
                 goto finish;
             }
         }
diff --git a/src/rpc/virnetsshsession.c b/src/rpc/virnetsshsession.c
index 59013c7..7c7d246 100644
--- a/src/rpc/virnetsshsession.c
+++ b/src/rpc/virnetsshsession.c
@@ -341,7 +341,7 @@ virNetSSHCheckHostKey(virNetSSHSessionPtr sess)
             if (i > 0) {
                 virReportError(VIR_ERR_SSH, "%s",
                                _("no suitable method to retrieve "
-                                 "authentication cretentials"));
+                                 "authentication credentials"));
                 return -1;
             }
 
@@ -733,7 +733,7 @@ virNetSSHAuthenticateKeyboardInteractive(virNetSSHSessionPtr sess,
         case VIR_NET_SSH_AUTHCB_NO_METHOD:
             virReportError(VIR_ERR_SSH, "%s",
                            _("no suitable method to retrieve "
-                             "authentication cretentials"));
+                             "authentication credentials"));
             return -1;
         case VIR_NET_SSH_AUTHCB_OOM:
             virReportOOMError();
diff --git a/src/util/virhash.c b/src/util/virhash.c
index 5794d6f..1576dd3 100644
--- a/src/util/virhash.c
+++ b/src/util/virhash.c
@@ -360,7 +360,7 @@ virHashUpdateEntry(virHashTablePtr table, const void *name,
  *
  * Find the userdata specified by @name
  *
- * Returns the a pointer to the userdata
+ * Returns a pointer to the userdata
  */
 void *
 virHashLookup(virHashTablePtr table, const void *name)
@@ -388,7 +388,7 @@ virHashLookup(virHashTablePtr table, const void *name)
  * Find the userdata specified by @name
  * and remove it from the hash without freeing it.
  *
- * Returns the a pointer to the userdata
+ * Returns a pointer to the userdata
  */
 void *virHashSteal(virHashTablePtr table, const void *name)
 {
-- 
1.7.10